<template>
  <st-content heading="Universidad">
    <div class="content-body">
      <div class="table-heading">
        <st-subtitle text="Datos generales" />
        <st-edit-btn @click="open" />
      </div>
      <v-row>
        <v-col md="12" v-for="(field,index) in fields" :key="index">
          <v-row align="center" no-gutters>
            <v-col md="4">
              <v-label>{{ field.label }}</v-label>
            </v-col>
            <v-col md="8">
              <v-label>{{ field.value }}</v-label>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
      <v-row>
        <v-col md="6">
          <v-row align="center" no-gutters>
            <v-col md="4">
              <v-label>Logo:</v-label>
            </v-col>
            <v-col md="8">
              <v-img :src="logo" height="200" contain />
              <!--<img src height="200" />-->
            </v-col>
          </v-row>
        </v-col>
      </v-row>
      <v-dialog v-model="dialog" max-width="400">
        <v-card class="pop2">
          <v-card-text class="pop2">
            <st-title text="Datos de la universidad" />
            <v-form ref="form">
              <div class="box">
                <v-text-field
                  v-for="(field, index) in fields2"
                  v-model="field.value"
                  :counter="field.counter"
                  :rules="field.rules"
                  :label="field.label"
                  :key="index"
                  required
                />

                <v-file-input
                  label="Selecciona el archivo a subir"
                  accept="image/png, image/jpeg, image/bmp"
                  v-model="file"
                  @change="Preview_image"
                />
                <v-row justify="center">
                  <img src height="100" />
                </v-row>
              </div>

              <div class="content-footer">
                <st-secondary-btn nombre="Cancelar" @click="dialog=false" />
                <st-primary-btn :loading="loading" nombre="Actualizar" @click="saveChanges" />
              </div>
            </v-form>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
  </st-content>
</template>

<script>
const toBase64 = file =>
  new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsBinaryString(file);
    reader.onload = () => resolve(btoa(reader.result));
    reader.onerror = error => reject(error);
  });
export default {
  data() {
    return {
      items: this.value ? this.value.slice() : [],
      dialog: false,
      loading: false,
      data: null,
      type: null,
      selected_: null,
      file: null,
      nombreUnidad: "",
      fields: {
        nombres: {
          label: "Nombre:",
          value: "Pontificia Universidad Católica del Perú"
        },
        correo: { label: "Dominio:", value: "pucp.edu.pe" }
      },
      fields2: {
        nombres: { label: "Nombre", value: "LOL" },
        correo: { label: "Dominio", value: "UWU" }
      },
      logo: "../../images/logo.jpg" //preview: "https://picsum.photos/510/300?random"
    };
  },
  methods: {
    Preview_image() {
      var preview = document.querySelector("img");
      var reader = new FileReader();

      reader.onloadend = function() {
        preview.src = reader.result;
      };

      if (this.file) {
        reader.readAsDataURL(this.file);
      } else {
        preview.src = "";
      }
    },
    open() {
      this.dialog = true;
      this.fields2.nombres.value = this.fields.nombres.value;
      this.fields2.correo.value = this.fields.correo.value;
    },
    async saveChanges() {
      this.loading = true;
      let b64 = "";
      let extension = "";
      if (this.file) {
        let name = this.file.name;
        try {
          b64 = await toBase64(this.file);
        } catch (e) {
          this.$store.commit("setError", e);
        }
        extension = this.file.type.substr(6, 4);
      }
      let data = {};
      if (b64) {
         data = {
          nombre: this.fields2.nombres.value, //"Pontifica Universidad Católica del Perú",
          dominio: this.fields2.correo.value, //
          logo: b64,
          extension: extension
        };
      } else {
        data = {
          nombre: this.fields2.nombres.value, //"Pontifica Universidad Católica del Perú",
          dominio: this.fields2.correo.value,
          extension: ""
        };
      }

      try {
        let response = await this.$api.updateUniversity(data);
        this.fields.nombres.value = response.data.data.universidad.nombre;
        this.fields.correo.value = response.data.data.universidad.dominio;
        if(response.data.data.universidad.logo.url) this.logo = response.data.data.universidad.logo.url;
      } catch (e) {
        this.$store.commit("setError", e);
      }
      this.loading = false;
      this.dialog = false;
    },
    async ini() {
      this.fields.nombres.value = "Cargando...";
      this.fields.correo.value = "Cargando...";
      try {
        let response = await this.$api.getUniversity();
        this.fields.nombres.value = response.data.data.universidad.nombre;
        this.fields.correo.value = response.data.data.universidad.dominio;
        this.logo = response.data.data.universidad.logo.url;
      } catch (e) {
        this.$store.commit("setError", e);
      }
    }
  },
  mounted() {
     this.ini();
  }
};
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
.pop2 {
  height: 700;
  padding-top: 20px;
}
</style>